"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _GitServiceFactory = _interopRequireDefault(require("../lib/GitServiceFactory"));

var oauth = _interopRequireWildcard(require("../lib/OAuth"));

var RSA = _interopRequireWildcard(require("../lib/RSA"));

var _Staticman = _interopRequireDefault(require("../lib/Staticman"));

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function () { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var _default = async (req, res) => {
  const staticman = await new _Staticman.default(req.params);
  staticman.setConfigPath();
  let requestAccessToken;

  switch (req.params.service) {
    case 'gitlab':
      requestAccessToken = siteConfig => oauth.requestGitLabAccessToken(req.query.code, siteConfig.get('gitlabAuth.clientId'), siteConfig.get('gitlabAuth.clientSecret'), siteConfig.get('gitlabAuth.redirectUri'));

      break;

    default:
      requestAccessToken = siteConfig => oauth.requestGitHubAccessToken(req.query.code, siteConfig.get('githubAuth.clientId'), siteConfig.get('githubAuth.clientSecret'), siteConfig.get('githubAuth.redirectUri'));

  }

  return staticman.getSiteConfig().then(requestAccessToken).then(async accessToken => {
    const git = await (0, _GitServiceFactory.default)(req.params.service, {
      oauthToken: accessToken,
      version: req.params.version
    }); // TODO: Simplify this when v2 support is dropped.

    const getUser = req.params.version === '2' && req.params.service === 'github' ? git.api.users.getAuthenticated({}).then(({
      data
    }) => data) : git.getCurrentUser();
    return getUser.then(user => {
      res.send({
        accessToken: RSA.encrypt(accessToken),
        user
      });
    });
  }).catch(err => {
    console.log('ERR:', err);
    const statusCode = err.statusCode || 401;
    res.status(statusCode).send({
      statusCode,
      message: err.message
    });
  });
};

exports.default = _default;