"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _bunyanSlack = _interopRequireDefault(require("bunyan-slack"));

var _logger = _interopRequireDefault(require("@dadi/logger"));

var _config = _interopRequireDefault(require("../config"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

class Logger {
  constructor() {
    const options = {
      enabled: true,
      level: 'info',
      stream: process.stdout
    };

    if (typeof _config.default.get('logging.slackWebhook') === 'string') {
      this.formatFn = t => `\`\`\`\n${t}\n\`\`\``;

      options.stream = new _bunyanSlack.default({
        webhook_url: _config.default.get('logging.slackWebhook')
      });
    }

    _logger.default.init(options);
  }

  info(data) {
    const formattedData = typeof this.formatFn === 'function' ? this.formatFn(data) : data;

    _logger.default.info(formattedData);
  }

}

var _default = new Logger();

exports.default = _default;