"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.decrypt = exports.encrypt = void 0;

var _nodeRsa = _interopRequireDefault(require("node-rsa"));

var _config = _interopRequireDefault(require("../config"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const key = new _nodeRsa.default();

const encrypt = text => {
  try {
    key.importKey(_config.default.get('rsaPrivateKey'), 'private');
    const encryptedText = key.encrypt(text, 'base64');
    return encryptedText;
  } catch (err) {
    return null;
  }
};

exports.encrypt = encrypt;

const decrypt = text => {
  try {
    key.importKey(_config.default.get('rsaPrivateKey'), 'private');
    return key.decrypt(text, 'utf8');
  } catch (err) {
    return null;
  }
};

exports.decrypt = decrypt;