"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _TypeUtils = _interopRequireDefault(require("../TypeUtils"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

class User {
  /**
   * @param {string} type
   * @param {string} username
   * @param {string} email
   * @param {string} name
   * @param {string=""} avatarUrl
   * @param {string=""} bio
   * @param {string=""} siteUrl
   * @param {string=""} organisation
   */
  constructor(type, username, email, name, avatarUrl = '', bio = '', siteUrl = '', organisation = '') {
    (0, _TypeUtils.default)(type);
    (0, _TypeUtils.default)(username);
    (0, _TypeUtils.default)(email);
    (0, _TypeUtils.default)(name);
    (0, _TypeUtils.default)(avatarUrl);
    (0, _TypeUtils.default)(bio);
    (0, _TypeUtils.default)(siteUrl);
    (0, _TypeUtils.default)(organisation);
    this.type = type;
    this.username = username;
    this.email = email;
    this.name = name;
    this.avatarUrl = avatarUrl;
    this.bio = bio;
    this.siteUrl = siteUrl;
    this.organisation = organisation;
  }

}

exports.default = User;